/****************************************************************************
 * libwiigui Template
 * Tantric 2009
 *
 * demo.cpp
 * Basic template/demonstration of libwiigui capabilities. For a
 * full-featured app using many more extensions, check out Snes9x GX.
 ***************************************************************************/

#include <gccore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ogcsys.h>
#include <unistd.h>
#include <wiiuse/wpad.h>
#include <fat.h>

#include "FreeTypeGX.h"
#include "video.h"
#include "audio.h"
#include "menu.h"
#include "input.h"
#include "filelist.h"
#include "demo.h"
#include "di_shit.h"
#include "BootHomebrew/BootHomebrew.h"

//#define DBG

struct SSettings Settings;
int ExitRequested = 0;
extern u32 homebrewsize;
extern int region;
extern int widescreen;
int ResetRequested = 0;

void ExitApp()
{
	ShutoffRumble();
	StopGX();
	WPAD_Shutdown();
	FST_Unmount();
	VIDEO_SetBlack(true);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	//gprintf("exiting.  size: %016llx\n", homebrewsize );
	if( homebrewsize )
	{
	    BootHomebrew();
	}
#ifdef DBG
	if( !strncmp( (char*)0x80001804, "STUBHAXX", strlen("STUBHAXX") ) )
	{
	    exit(0);
	    while( 1 );
	}
#endif
	SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0);
}

void ResetCB()
{
    ResetRequested = 1;
}

int
main(int argc, char *argv[])
{
    s32 ret;
#ifdef DBG
	IOS_ReloadIOS( 36 );//simply for testing, remove for release as it will surely break loading from USB
	ret = CONF_Init();
#endif
	//print basic info
	gprintf("PunEmu intro 1.0\t\tBuilt: %s %s\nmain( %d", __DATE__, __TIME__, argc );
	for( int i = 0; i < argc; i++ )
	    gprintf(", \"%s\"", argv[ i ] );
	gprintf(" )\n");

	if( argc >= 2 )
	    snprintf( lastEmu, sizeof( lastEmu ), "%s", argv[ 1 ] );

	else lastEmu[ 0 ] = 0;

	InitVideo(); // Initialize video
	SetupPads(); // Initialize input
	InitAudio(); // Initialize audio
	SYS_SetResetCallback( ResetCB ); //make the reset button do something cool
	//fatInitDefault(); // Initialize file system
	InitFreeType((u8*)font_ttf, font_ttf_size); // Initialize font system
	InitGUIThreads(); // Initialize GUI

#ifdef DBG
	if( ret < 0 )
	{
	    gprintf("CONF_Init(): %d\n", ret );
	}
	else
	{
#endif
	    ret = CONF_GetRegion();
	    if( ret < 0 )
		gprintf("CONF_GetRegion(): %d\n", ret );
	    else region = ret;

	    ret = CONF_GetAspectRatio();
	    if( ret < 0 )
		gprintf("CONF_GetAspectRatio(): %d\n", ret );
	    else widescreen = ret;
#ifdef DBG
	}
#endif

	if( argc < 2 )
	{
	    MainMenu( MENU_STRAP );
	}

	 else
	     MainMenu( MENU_STRAP_SILENT );
	    //MainMenu( MENU_ABOUT );
	    //MainMenu( MENU_EMU_SELECT );

}
