/****************************************************************************
 * FCE Ultra
 * Nintendo Wii/Gamecube Port
 *
 * Tantric 2008-2009
 *
 * fileop.h
 *
 * File operations
 ****************************************************************************/

#ifndef _FILEOP_H_
#define _FILEOP_H_

#include <gccore.h>
#include <stdio.h>
#include <string.h>
#include <ogcsys.h>
#include <fat.h>
#include <unistd.h>

#ifdef __cplusplus
extern "C" {
#endif

s32 WDVD_Init(void);
s32 WDVD_OpenDataPartition();
s32 WDVD_Close(void);
s32 WDVD_Read(void *buf, u32 len, u64 offset);
s32 WDVD_ClosePartition(void);
s32 WDVD_GetHandle();
bool WDVD_IsPartitionOpen();
s32 WDVD_GetMainDol( void *outbuf, u32* size );

bool FSTIsMounted();
bool FST_Mount();
bool FST_Unmount();

//simple debugging.  this seems like a good enough place to put this
void gprintf(const char *str, ...);
void hexdump(void *d, int len);

#ifdef __cplusplus
}
#endif

#endif
