/****************************************************************************
 * FCE Ultra
 * Nintendo Wii/Gamecube Port
 *
 * Tantric 2008-2009
 *
 * cheatmgr.cpp
 *
 * Cheat handling
 ***************************************************************************/

#include <malloc.h>

#include "fceugx.h"
#include "fceusupport.h"
#include "fileop.h"
#include "filebrowser.h"
#include "menu.h"

#include "fceultra/cheat.h"

int numcheats = 0;

/****************************************************************************
 * LoadCheats
 *
 * Loads cheat file from save buffer
 * Custom version of FCEU_LoadGameCheats()
 ***************************************************************************/
//commented code in this file adds support for lines such as
//  "gamegenie:BLABLABL:code description"
// into the .cht file.  but as i have converted all gamegenie codes to the usual format, there is no need for this stuff anymore
/*int AddGGCode( const char *str, unsigned int *a, unsigned int *v, unsigned int *c, char ** name )
{
    gprintf( "AddGGCode( \"%s\" )\n", str );

    int len = strlen( str );

    char *code = (char*)malloc( len + 1 );
    if( !code )
	return 0;

    memcpy( code, str, len );
    code[ len ] = '\0';

    char* colon = strstr( code, ":" );
    colon[ 0 ] = 0;
    gprintf("\tcode: \"%s\"\n", code );
    int ret = FCEUI_DecodeGG( code, (int*)a, (int*)v, (int*)c );
    if( !ret )
    {
	free( code );
	return 0;
    }

    char *newname = (char*)malloc( len - strlen( code ) );
    if( !newname )
    {
	free( code );
	return 0;
    }
    memcpy( newname, code + strlen( code ) + 1, len - strlen( code ) );
    newname[ len - strlen( code ) ] = '\0';

    *name = newname;
    gprintf("\tconvert( \"%s\" ): %d\n", code, ret );

    free( code );

    return 1;
}*/

static int LoadCheats (int length)
{
	unsigned int addr;
	unsigned int val;
	unsigned int status;
	unsigned int type;
	unsigned int compare;
	int x;

	char *namebuf;
	int tc=0;

	char * linebreak = strtok((char *)savebuffer, "\n");

	while(linebreak != NULL)
	{

		char *tbuf=linebreak;
		int doc=0;
		//int gg = -1;
		//gprintf("cheatline: %s\n", tbuf );

		addr=val=compare=status=type=0;

		if(tbuf[0]=='S')
		{
			tbuf++;
			type=1;
		}
		else type=0;

		if(tbuf[0]=='C')
		{
			tbuf++;
			doc=1;
		}

		if(tbuf[0]==':')
		{
			tbuf++;
			status=0;
		}
		else status=1;

		/*if( !strncmp( "gamegenie:", tbuf, strlen( "gamegenie:" ) ) )
		{
		    gg = 0;
		    type = 1;
		    doc = 1;
		    //char* namebuf = NULL;
		    gprintf( "found gg code: %s\n", tbuf );
		    if( AddGGCode( tbuf + strlen( "gamegenie:" ), &addr, &val, &compare, &namebuf ) )
			gg = 1;
		    else
		    {
			linebreak = strtok(NULL, "\n");
			continue;
		    }
		    gprintf("AddGGCode( %04x, %02x, %02x ): %d\n", addr, val, compare, gg );
		    if( gg )
			gprintf("name: \"%s\"\n", namebuf );
		}*/

		if( doc )//&& gg == -1 )
		{
			char *neo=&tbuf[4+2+2+1+1+1];
			if(sscanf(tbuf,"%04x%*[:]%02x%*[:]%02x",&addr,&val,&compare)!=3)
			{
			    linebreak = strtok(NULL, "\n");
			    continue;
			}
			namebuf=(char *)malloc(strlen(neo)+1);
			strcpy(namebuf,neo);
		}
		else //if( gg == -1 )
		{
			char *neo=&tbuf[4+2+1+1];
			if(sscanf(tbuf,"%04x%*[:]%02x",&addr,&val)!=2)
			{
			    linebreak = strtok(NULL, "\n");
			    continue;
			}
			namebuf=(char *)malloc(strlen(neo)+1);
			strcpy(namebuf,neo);
		}

		for(x=0;x<(int)strlen(namebuf);x++)
		{
			if(namebuf[x]==10 || namebuf[x]==13)
			{
				namebuf[x]=0;
				break;
			}
			else if(namebuf[x]<0x20) namebuf[x]=' ';
		}

		AddCheatEntry(namebuf,addr,val,doc?compare:-1,status,type);
		FCEUI_ToggleCheat(tc); // turn cheat off
		tc++;

		// find next line break
		linebreak = strtok(NULL, "\n");
	}
	RebuildSubCheats();
	return tc;
}

/****************************************************************************
 * SetupCheats
 *
 * Erases any prexisting cheats, loads cheats from a cheat file
 * Called when a ROM is first loaded
 ***************************************************************************/
void
SetupCheats()
{
	FCEU_PowerCheats();
	numcheats = 0;

	if(GameInfo->type == GIT_NSF)
		return;

	char filepath[1024];
	size_t offset = 0;

	int device = GCSettings.SaveMethod;

	if(device == DEVICE_AUTO)
		device = autoSaveMethod(SILENT);

	//if(device == DEVICE_AUTO)
	//	return;

	if(!MakeFilePath(filepath, FILE_CHEAT))
		return;

	AllocSaveBuffer();

	offset = LoadFile(filepath, SILENT);

	// load cheat file if present
	if(offset > 0)
		numcheats = LoadCheats(offset);

	FreeSaveBuffer ();
}

bool FindGameGenie()
{
//    printf("FindGameGenie()\n");
	if (GENIEROM)
		return true;

	if(GCSettings.LoadMethod == DEVICE_AUTO)
		GCSettings.LoadMethod = autoLoadMethod();

	if(GCSettings.LoadMethod == DEVICE_AUTO)
	{
//	    printf("\tfail 1\n");
	    return false;
	}

	char * tmpbuffer = (char *) memalign(32, 512 * 1024);
	if(!tmpbuffer)
	{
//	    printf("\tfail 2\n");
	    return false;
	}

	size_t romSize = 0;
	char filepath[1024];

	sprintf (filepath, "%s%s/gg.rom", pathPrefix[GCSettings.LoadMethod], APPFOLDER);
//	sprintf(filepath, "dvd:/Nintendo/Game Genie.rom" );
//	printf("\tlooking for \"%s\"\n", filepath );
	romSize = LoadFile(tmpbuffer, filepath, 0, SILENT);
	if(romSize == 0 && strlen(appPath) > 0)
	{
		sprintf (filepath, "%s/gg.rom", appPath);
//		printf("\tlooking for \"%s\"\n", filepath );
		romSize = LoadFile(tmpbuffer, filepath, 0, SILENT);
	}

	if (romSize > 0)
	{
		GENIEROM=(uint8 *)malloc(4096+1024);

		if(tmpbuffer[0]==0x4E)  /* iNES ROM image */
		{
			memcpy(GENIEROM,tmpbuffer+16,4096);
			memcpy(GENIEROM+4096,tmpbuffer+16400,256);
		}
		else
		{
			memcpy(GENIEROM,tmpbuffer,4352);
		}

		/* Workaround for the FCE Ultra CHR page size only being 1KB */
		for(int x=0; x<4; x++)
			memcpy(GENIEROM+4096+(x<<8),GENIEROM+4096,256);
	}
	free(tmpbuffer);
//	printf("\tromSize: %u\n", romSize );
	
	if(romSize > 0)
		return true;
	
	return false;
}

void OpenGameGenie()
{
	if(!GCSettings.gamegenie)
		geniestage=0;
	else if (FindGameGenie())
		geniestage=1;
}
