/****************************************************************************
 * Snes9x Nintendo Wii/Gamecube Port
 *
 * Tantric 2008-2010
 *
 * cheatmgr.cpp
 *
 * Cheat handling
 ***************************************************************************/


#include "port.h"
#include "cheats.h"

#include "snes9xgx.h"
#include "fileop.h"
#include "filebrowser.h"
#include "libdisk/fst.h"

extern SCheatData Cheat;

//load the ".ggp" file with game genie/pro action replay cheats
static bool LoadGGPCheatFile (int length)
{
    uint32 addr;
    uint8 val;
    unsigned int type;

    char * linebreak = strtok((char *)savebuffer, "\n");

    while(linebreak != NULL)
    {
	if( Cheat.num_cheats >= MAX_CHEATS )
		break;

	    char *tbuf=linebreak;
	    bool ok = false;
	    //gprintf("cheatline: \"%s\"\n", tbuf );

	    addr=val=type=0;

	    if( tbuf[ 0 ] == 'G' )
	    {
		    tbuf += 2;
		    char code[ 10 ];
		    memcpy( &code, tbuf, 9 );
		    code[ 9 ] = 0;

		    tbuf += 10;

		    char *res = (char*)S9xGameGenieToRaw( (const char*)&code, addr, val );
		    if( res )
			gprintf("%s\n", res );
		    else
			ok = true;
	    }// uncomment to enable PAR cheats.  as of right now, they kinda suck with the snes9x cheat handling
	    // http://code.google.com/p/snes9x-gtk/issues/detail?id=53
	    /*else if( tbuf[ 0 ] == 'P')
	    {
		tbuf += 2;
		char code[ 9 ];
		memcpy( &code, tbuf, 8 );
		code[ 8 ] = 0;

		tbuf += 9;

		char *res = (char*)S9xProActionReplayToRaw( (const char*)&code, addr, val );
		if( res )
		    gprintf("%s\n", res );

		else
		    ok = true;
	    }
	    else gprintf("WTF\n");*/

	    if( ok )
	    {
		Cheat.c [Cheat.num_cheats].enabled = 0; // cheats always off
		Cheat.c [Cheat.num_cheats].byte = val;
		Cheat.c [Cheat.num_cheats].address = addr;
		Cheat.c [Cheat.num_cheats].saved_byte = 0;
		Cheat.c [Cheat.num_cheats].saved = 0;
		snprintf( Cheat.c[ Cheat.num_cheats ].name, sizeof( Cheat.c[ Cheat.num_cheats ].name ), "%s", tbuf );
		Cheat.num_cheats++;
	    }


	    // find next line break
	    linebreak = strtok(NULL, "\n");
    }


    return true;
}

/****************************************************************************
 * LoadCheatFile
 *
 * Loads cheat file from save buffer
 * Custom version of S9xLoadCheatFile()
 ***************************************************************************/

static bool LoadCheatFile (int length)
{
	uint8 data [28];
	int offset = 0;

	while (offset < length)
	{
		if(Cheat.num_cheats >= MAX_CHEATS || (length - offset) < 28)
			break;

		memcpy (data, savebuffer+offset, 28);
		offset += 28;

		Cheat.c [Cheat.num_cheats].enabled = 0; // cheats always off
		Cheat.c [Cheat.num_cheats].byte = data [1];
		Cheat.c [Cheat.num_cheats].address = data [2] | (data [3] << 8) | (data [4] << 16);
		Cheat.c [Cheat.num_cheats].saved_byte = data [5];
		Cheat.c [Cheat.num_cheats].saved = (data [0] & 8) != 0;
		memcpy (Cheat.c [Cheat.num_cheats].name, &data[8], 20);
		Cheat.c [Cheat.num_cheats].name[20] = 0;
		Cheat.num_cheats++;
	}
	return true;
}

/****************************************************************************
 * SetupCheats
 *
 * Erases any prexisting cheats, loads cheats from a cheat file
 * Called when a ROM is first loaded
 ***************************************************************************/
void
WiiSetupCheats()
{
	memset(Cheat.c, 0, sizeof(Cheat.c));
	Cheat.num_cheats = 0;

	char filepath[1024];
	int offset = 0;

	if( MakeFilePath(filepath, FILE_CHEAT) )
	{

	    AllocSaveBuffer();

	    offset = LoadFile(filepath, SILENT);

	    // load cheat file if present
	    if(offset > 0)
		    LoadCheatFile (offset);

	    FreeSaveBuffer ();
	}

	if( MakeFilePath(filepath, FILE_CHEAT_GGP) )
	{

	    AllocSaveBuffer();

	    offset = LoadFile(filepath, SILENT);

	    // load cheat file if present
	    if(offset > 0)
		    LoadGGPCheatFile(offset);

	    FreeSaveBuffer ();
	}


}
